// ----
// ---- file   : SyModuleChnStereoSplit.cpp
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2013 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 28May2013
// ----
// ----
// ----

#include "tksynth.h"

#include "SyModuleChnStereoSplit.h"


void SyModuleChnStereoSplit::init(void) {
   SyModule::init();

   allocInputs(1);
   addInput("smp",   SYPORT_MODE_SE, -1.0f,  1.0f, 0.0f); // #0

   allocOutputs(2);
   addOutput("smp_l", SYPORT_MODE_SE); // #0
   addOutput("smp_r", SYPORT_MODE_SE); // #1
}

void SyModuleChnStereoSplit::reset(void) {
   SyModule::reset();
}

void SyModuleChnStereoSplit::doCalc(sUI _framesAdvance) {

   SyInput *in_smp   = inputs[0];
   SyOutput *out_smp_l = outputs[0];
   SyOutput *out_smp_r = outputs[1];

   sUI i = 0;
   sF32 out[2];
   out[0] = 0.0f;
   out[1] = 0.0f;

   Dsyloopch(in_smp)
   {
      out[i] = Dsyval(in_smp);

      i = (i + 1) & 1;
   }

   // Scale/offset output samples and copy to output ports
   Dsyoutmono(out_smp_l, out[0]);
   Dsyoutmono(out_smp_r, out[1]);
}
