// ----
// ---- file   : SyModuleDlyModulate.h
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2010 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 23Jun2010, 07Oct2010
// ----          
// ----
// ----
// ----

#ifndef __TKSYNTH_MODULE_DLY_MODULATE_H__
#define __TKSYNTH_MODULE_DLY_MODULATE_H__

YG("tksynth");


#define SYMODULEDLYMODULATE_MAX_DELAY_SAMPLES 48000


class SyModuleDlyModulateState {
  public:
   sF32 ringbuf[SYMODULEDLYMODULATE_MAX_DELAY_SAMPLES];
};


YC class SyModuleDlyModulate : public SyModule {

  protected:
   sSI ringbuf_offset;

   sF32 angle;

   SyModuleDlyModulateState *state;


  public:
   SyModuleDlyModulate(void);
   ~SyModuleDlyModulate();

   YAC_POOLED(SyModuleDlyModulate, YAC_POOL_PRIORITY_LOW);

   void init   (void);
   void reset  (void);
   void doCalc (sUI _framesAdvance);
};


#endif // __TKSYNTH_MODULE_DLY_MODULATE_H__
