// ----
// ---- file   : SyModuleDlySimple.h
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2010-2012 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 15Jun2010, 07Oct2010, 05Feb2012
// ----          
// ----
// ----
// ----

#ifndef __TKSYNTH_MODULE_DLY_SIMPLE_H__
#define __TKSYNTH_MODULE_DLY_SIMPLE_H__

YG("tksynth");


#define SYMODULEDLYSIMPLE_MAX_DELAY_SAMPLES 48000


class SyModuleDlySimpleState {
  public:
   sF32 ringbuf[SYMODULEDLYSIMPLE_MAX_DELAY_SAMPLES];
   sF32 next_smp;
   sF32 last_dly_smp;

   inline void push(sSI off, sF32 feedback) {
      ringbuf[off] = next_smp + last_dly_smp * feedback;
   }
};


YC class SyModuleDlySimple : public SyModule {

  protected:
   sF32 ringbuf_offset;

   SyModuleDlySimpleState *state;

   sF32 tick_duration;
   sSI dampen_framecount;

  public:
   SyModuleDlySimple(void);
   ~SyModuleDlySimple();

   YAC_POOLED(SyModuleDlySimple, YAC_POOL_PRIORITY_LOW);
   ////YAC(SyModuleDlySimple);

   void init   (void);
   void reset  (void);
   void doCalc (sUI _framesAdvance);

   void setTickDuration (sF32 _tickDuration);
};


#endif // __TKSYNTH_MODULE_DLY_SIMPLE_H__
