// ----
// ---- file   : SyModuleDynCompressor.h
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2010-2013 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 29Jun2010, 07Oct2010, 28May2013
// ----
// ----
// ----

#ifndef __TKSYNTH_MODULE_DYN_COMPRESSOR_H__
#define __TKSYNTH_MODULE_DYN_COMPRESSOR_H__

YG("tksynth");


YC class SyModuleDynCompressor : public SyModule {

  protected:
#define SYMODULE_DYN_COMPRESSOR_RMS_WINDOW_SIZE 32

   static sF32 rms_weights[SYMODULE_DYN_COMPRESSOR_RMS_WINDOW_SIZE];
   
   sF32 buf[SYMODULE_DYN_COMPRESSOR_RMS_WINDOW_SIZE];
   sSI buf_offset;

   sSI env_mode; // 0=idle, 1=attack, 2=release
   sF32 env_phase;
   sF32 damp;

  protected:
   void CalcRMSWeights(void);

   sF32 calcRMS(sF32 _inSmp);


  public:
   YAC_POOLED(SyModuleDynCompressor, YAC_POOL_PRIORITY_LOW);

   void init   (void);
   void reset  (void);
   void doCalc (sUI _framesAdvance);
};


#endif // __TKSYNTH_MODULE_DYN_COMPRESSOR_H__
