// ----
// ---- file   : SyModuleFltPhaser6St.h
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2009-2010 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 24Jun2010, 07Oct2010
// ----          
// ----
// ----
// ----

#ifndef __TKSYNTH_MODULE_FLT_PHASER_6ST_H__
#define __TKSYNTH_MODULE_FLT_PHASER_6ST_H__

YG("tksynth");


class SyModuleFltPhaser6StAllPassDelay {
  public:
   sF32 a1;
   sF32 zm1;

   void delay(float _delay) { //sample delay time
      // Calculate filter coefficient
      a1 = (1.0f - _delay) / (1.0f + _delay);
   }
   
   float update( float _inSamp ) {
      // Filter sample
      float y = _inSamp * -a1 + zm1;
      zm1 = y * a1 + _inSamp;
      
      return y;
   }

};

class SyModuleFltPhaser6StState {
  public:
   sF32 zm1;

   SyModuleFltPhaser6StAllPassDelay alps[6];
};


YC class SyModuleFltPhaser6St : public SyModule {
  protected:
   SyModuleFltPhaser6StState state[SYPORT_MAXCHANNELS];

   sF32 lfo_phase;

  public:
   YAC_POOLED(SyModuleFltPhaser6St, YAC_POOL_PRIORITY_LOW);

   void init   (void);
   void reset  (void);
   void doCalc (sUI _framesAdvance);
};


#endif // __TKSYNTH_MODULE_FLT_PHASER_6ST_H__
