// ----
// ---- file   : SyModuleOpMin.cpp
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2013 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 29May2013
// ----
// ----
// ----

#include "tksynth.h"

#include "SyModuleOpMin.h"


void SyModuleOpMin::init(void) {
   SyModule::init();

   allocInputs(2);
   addInput("smp_a",   SYPORT_MODE_SE, -1.0f,  1.0f, 0.0f);  // #0
   addInput("smp_b",   SYPORT_MODE_SE, -1.0f,  1.0f, 0.0f);  // #1

   allocOutputs(1);
   addOutput("smp", SYPORT_MODE_SE); // #0
}

void SyModuleOpMin::reset(void) {
   SyModule::reset();
}

void SyModuleOpMin::doCalc(sUI _framesAdvance) {

   SyInput *in_smp_a  = inputs[0];
   SyInput *in_smp_b  = inputs[1];

   SyOutput *out_smp = outputs[0];

   Dsyloopch(out_smp)
   {
      sF32 a = Dsyval(in_smp_a);
      sF32 b = Dsyval(in_smp_b);

      sF32 out = (a < b) ? a : b;

      Dsyout(out_smp, out);
   }
}
