// ----
// ---- file   : SyModuleOpMixMax.cpp
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2013 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 29May2013
// ----
// ----
// ----

#include "tksynth.h"

#include "SyModuleOpMixMax.h"


void SyModuleOpMixMax::init(void) {
   SyModule::init();

   allocInputs(2);
   addInput("smp_a",   SYPORT_MODE_SE, -1.0f,  1.0f, 0.0f);  // #0
   addInput("smp_b",   SYPORT_MODE_SE, -1.0f,  1.0f, 0.0f);  // #1
   // // addInput("gain_a",  SYPORT_MODE_BE,-30.0f, 30.0f, 1.0f);  // #2
   // // addInput("gain_b",  SYPORT_MODE_BE,-30.0f, 30.0f, 1.0f);  // #2

   allocOutputs(1);
   addOutput("smp", SYPORT_MODE_SE); // #0
}

void SyModuleOpMixMax::reset(void) {
   SyModule::reset();
}

void SyModuleOpMixMax::doCalc(sUI _framesAdvance) {

   SyInput *in_smp_a  = inputs[0];
   SyInput *in_smp_b  = inputs[1];
   // // SyInput *in_gain_a = inputs[2];
   // // SyInput *in_gain_b = inputs[3];

   SyOutput *out_smp = outputs[0];

   // // sF32 gainA = Dsyctl(in_gain_a);
   // // sF32 gainB = Dsyctl(in_gain_b);

   Dsyloopch(out_smp)
   {
      sF32 a = Dsyval(in_smp_a);//// * gainA;
      sF32 b = Dsyval(in_smp_b);//// * gainB;

      sF32 out = (a + b) - (a * b);

      Dsyout(out_smp, out);
   }
}
