// ----
// ---- file   : SyModuleOsc.h
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2009-2010 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 10May2009, ..., 08Jun2090, 
// ----          22May2010, 02Jul2010
// ----
// ----
// ----

#ifndef __TKSYNTH_MODULE_OSC_H__
#define __TKSYNTH_MODULE_OSC_H__

YG("tksynth");


YCR class SyModuleOsc : public SyModule {
  public:
   sF32 *freq_table;
   sBool b_linear_freq; // use notetable
   sBool b_synczerox;   // 1=hardsync when sync input crosses zero, 0=sync when sync input is >0

  public:
   YAC(SyModuleOsc);
   
   SyModuleOsc(void);
   ~SyModuleOsc();

   YM void setFreqTable(YAC_Object *_freqTable);

   YM void  setEnableLinear(sBool _bEnabled);
   YM sBool getEnableLinear(void);

   YM void  setEnableSyncZeroX(sBool _bEnabled);
   YM sBool getEnableSyncZeroX(void);

   // overwrites SyModule::saveStream()
   sBool saveStream(YAC_Object *_ofs);
   sBool saveStreamOSC(YAC_Object *_ofs);

   // overwrites SyModule::readStream()
   sBool readStream(YAC_Object *_ifs);
   sBool readStreamOSC(YAC_Object *_ifs);

  protected:
   sF32 mapOscPitch(sF32 _freqOrNote) {
      if(b_linear_freq && freq_table)
      {
         return SyModule::NoteToFreq(freq_table, _freqOrNote);
      }
      else
      {
         return _freqOrNote;
      }
   }
};


#endif // __TKSYNTH_MODULE_OSC_H__
