// ----
// ---- file   : SyModuleOscNoise1.cpp
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2010 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 29Jun2010, 30Sep2010, 07Oct2010, 11Oct2010
// ----
// ----
// ----

/* 
 * based on "Fast Float Random Numbers" musicdsp.org post by dominik.ries[AT]gmail[DOT]com
 */


#include "tksynth.h"

#include "SyModuleOscNoise1.h"


void SyModuleOscNoise1::init(void) {
   SyModule::init();

   allocOutputs(1);
   addOutput("smp", SYPORT_MODE_SE); // #0

   for(sUI i=0; i<SYPORT_MAXCHANNELS; i++)
   {
      seed[i] = rand();
   }
}

void SyModuleOscNoise1::reset(void) {
   SyModule::reset();
}

void SyModuleOscNoise1::doCalc(sUI _framesAdvance) {

   SyOutput *output = outputs[0];

   Dsyloopch(output)
   {
      seed[chIdx] *= 16807;
      sF32 out = (sF32)seed[chIdx] * 4.6566129e-010f;
      Dsyout(output, out);
   }
}

void SyModuleOscNoise1::doCalcBlock(sUI _numFrames) {

   SyOutput *output = outputs[0];

   sUI k = 0;
   for(sUI i=0; i<_numFrames; i++)
   {
      for(sUI chIdx =0; chIdx<output->num_channels; chIdx++)
      {
         seed[chIdx] *= 16807;
         output->buffer[k++] = (sF32)seed[chIdx] * 4.6566129e-010f;
      }
   }
}
