// ----
// ---- file   : SyModuleOutFloatArray.h
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2009-2010 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 10May2009, ..., 08Jun2090, 
// ----          23May2010, 07Oct2010
// ----
// ----
// ----

#ifndef __TKSYNTH_MODULE_OUT_FLOATARRAY_H__
#define __TKSYNTH_MODULE_OUT_FLOATARRAY_H__

YG("tksynth");


YC class SyModuleOutFloatArray : public SyModule {
  public:
   sUI   num_iterations; // (todo) remove this. should never be != 1
   sF32  level;
   sBool b_blockmode;

  public:
   YAC_POOLED(SyModuleOutFloatArray, YAC_POOL_PRIORITY_LOW);

   SyModuleOutFloatArray(void);
   ~SyModuleOutFloatArray();

  public:
   void init(void);

  public:
   YM void setLevel (sF32 _level);
   YM sF32 getLevel (void);

   YM void setNumIterations (sUI _num);
   YM sUI  getNumIterations (void);

   YM void setEnableBlockMode (sSI _bEnabled);
   YM sSI  getEnableBlockMode (void);

   YM void calcStereoFloatArray(YAC_Object *_fa);

};


#endif // __TKSYNTH_MODULE_OUT_FLOATARRAY_H__
