// ----
// ---- file   : SyModuleWSSmoothStep.cpp
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2009-2010 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 10May2009, ..., 08Jun2009, 
// ----          23May2010, 30Sep2010, 07Oct2010
// ----
// ----
// ----

#include "tksynth.h"

#include "SyModuleWSSmoothStep.h"


void SyModuleWSSmoothStep::init(void) {
   SyModule::init();

   allocInputs(2);
   addInput("smp",   SYPORT_MODE_SE, -1.0f,  1.0f, 0.0f); // #0
   addInput("drive", SYPORT_MODE_BE,  1.0f, 16.0f, 1.0f); // #1

   allocOutputs(1);
   addOutput("smp", SYPORT_MODE_SE); // #0
}

void SyModuleWSSmoothStep::reset(void) {
   SyModule::reset();
}

void SyModuleWSSmoothStep::doCalc(sUI _framesAdvance) {

   SyInput *in_smp   = inputs[0];
   SyInput *in_drive = inputs[1];
   SyOutput *out_smp = outputs[0];

   Dsyloopch(in_smp)
   {
      sF64 in = Dsyval(in_smp) * Dsyctl(in_drive);
      if(in > 1.0)
         in = 1.0;
      else if(in < -1.0)
         in = -1.0;
      in = (in*0.5)+0.5;
      sF64 out= in*in*(3.0 - 2.0*in);
      out = (out*2.0)-1.0;

      Dsyout(out_smp, out);
   }
}
