// ----
// ---- file   : SyModuleWSTanhAsym.cpp
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2009-2010 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 10May2009, ..., 08Jun2009, 
// ----          23May2010, 30Sep2010, 07Oct2010
// ----
// ----
// ----

#include "tksynth.h"

#include "SyModuleWSTanhAsym.h"

// see <http://www.csounds.com/ezine/winter1999/processing/>

void SyModuleWSTanhAsym::init(void) {
   SyModule::init();

   allocInputs(2);
   addInput("smp",   SYPORT_MODE_SE, -1.0f,  1.0f, 0.0f); // #0
   addInput("drive", SYPORT_MODE_SE,  1.0f, 16.0f, 1.0f); // #1

   allocOutputs(1);
   addOutput("smp", SYPORT_MODE_SE); // #0
}

void SyModuleWSTanhAsym::reset(void) {
   SyModule::reset();
}

void SyModuleWSTanhAsym::doCalc(sUI _framesAdvance) {

   SyInput *in_smp   = inputs[0];
   SyInput *in_drive = inputs[1];
   SyOutput *out_smp = outputs[0];

   Dsyloopch(in_smp)
   {
      sF64 x = Dsyval(in_smp) * Dsyctl(in_drive);

      sF32 out= (sF32) (
         (exp(sin(x)*4) - exp(-sin(x)*4*1.25)) /
         (exp(sin(x)*4) + exp(-sin(x)*4))
                        );

      ////out = (out*0.5f) + 0.5f;

      out = Dyac_denorm_32(out);

      Dsyout(out_smp, out);
   }
}
