// ----
// ---- file   : SyModuleOpMul.cpp
// ---- author : Bastian Spiegel <bs@tkscript.de>
// ---- legal  : (c) 2010 by Bastian Spiegel. 
// ----          Distributed under terms of the GNU LESSER GENERAL PUBLIC LICENSE (LGPL). See 
// ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING for further information.
// ----
// ---- info   : This is part of the "syntracker" midi/audio sequencer.
// ----
// ---- changed: 24Sep2010
// ----
// ----
// ----

#include "tksynth.h"

#include "SyModuleOpMul.h"


void SyModuleOpMul::init(void) {
   SyModule::init();

   allocInputs(2);
   addInput("a", -1.0f, 1.0f, 1.0f);
   addInput("b", -1.0f, 1.0f, 1.0f);

   allocOutputs(1);
   addOutput("c");
}

void SyModuleOpMul::reset(void) {
   SyModule::reset();
}

void SyModuleOpMul::calc(sSI _tickCount) {
   SyModule::calc(_tickCount);

   SyInput *in_a = inputs[0];
   SyInput *in_b = inputs[1];
   SyOutput *out_c = outputs[0];

   Dsyloopch(in_smp)
   {
      sF32 out = Dsyval(in_a) * Dsyval(in_b);

      Dsyout(out_c, out);
   }
}
